Index: pbx.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx.c,v
retrieving revision 1.45
diff -u -r1.45 pbx.c
--- pbx.c	4 Sep 2003 22:46:06 -0000	1.45
+++ pbx.c	7 Sep 2003 02:08:01 -0000
@@ -20,6 +20,7 @@
 #include <asterisk/file.h>
 #include <asterisk/callerid.h>
 #include <asterisk/cdr.h>
+#include <asterisk/config.h>
 #include <asterisk/term.h>
 #include <asterisk/manager.h>
 #include <asterisk/ast_expr.h>
@@ -156,6 +157,7 @@
 static int pbx_builtin_atimeout(struct ast_channel *, void *);
 static int pbx_builtin_wait(struct ast_channel *, void *);
 static int pbx_builtin_setlanguage(struct ast_channel *, void *);
+static int pbx_builtin_resetcdr(struct ast_channel *, void *);
 static int pbx_builtin_setaccount(struct ast_channel *, void *);
 static int pbx_builtin_ringing(struct ast_channel *, void *);
 static int pbx_builtin_congestion(struct ast_channel *, void *);
@@ -263,6 +265,12 @@
 "which has no first step, the PBX will treat it as though the user dialed an\n"
 "invalid extension.\n" },
 
+	{ "ResetCDR", pbx_builtin_resetcdr,
+"Resets the Call Data Record",
+"  ResetCDR([write]):  Causes  the  Call Data Record to be reset, optionally\n"
+"storing the current CDR  before zeroing it out.  If not specified,  the CDR\n"
+"record WILL be stored.  Always returns 0.\n"  },
+
 	{ "ResponseTimeout", pbx_builtin_rtimeout,
 "Set maximum timeout awaiting response",
 "  ResponseTimeout(seconds): Set the maximum amount of time permitted after\n"
@@ -4063,6 +4071,16 @@
 {
 	/* Copy the language as specified */
 	strncpy(chan->language, (char *)data, sizeof(chan->language)-1);
+	return 0;
+}
+
+static int pbx_builtin_resetcdr(struct ast_channel *chan, void *data)
+{
+	/* Reset the CDR as specified */
+	if (data)
+		ast_cdr_reset(chan->cdr, ast_true((char *)data));
+	else
+		ast_cdr_reset(chan->cdr, 1);
 	return 0;
 }
 
